// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include "CCPACSWingCell.h"
#include "CPACSCellPositioningSpanwise.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "CTiglUIDObject.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSCellPositioningSpanwise::CPACSCellPositioningSpanwise(CCPACSWingCell* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSCellPositioningSpanwise::~CPACSCellPositioningSpanwise()
    {
        if (m_uidMgr) {
            if (m_ribDefinitionUID_choice2 && !m_ribDefinitionUID_choice2->empty()) m_uidMgr->TryUnregisterReference(*m_ribDefinitionUID_choice2, *this);
        }
    }

    const CCPACSWingCell* CPACSCellPositioningSpanwise::GetParent() const
    {
        return m_parent;
    }

    CCPACSWingCell* CPACSCellPositioningSpanwise::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSCellPositioningSpanwise::GetNextUIDParent() const
    {
        return m_parent;
    }

    CTiglUIDObject* CPACSCellPositioningSpanwise::GetNextUIDParent()
    {
        return m_parent;
    }

    CTiglUIDManager& CPACSCellPositioningSpanwise::GetUIDManager()
    {
        return *m_uidMgr;
    }

    const CTiglUIDManager& CPACSCellPositioningSpanwise::GetUIDManager() const
    {
        return *m_uidMgr;
    }

    void CPACSCellPositioningSpanwise::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read element eta1
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/eta1")) {
            m_eta1_choice1 = boost::in_place(reinterpret_cast<CCPACSWingCellPositionSpanwise*>(this), m_uidMgr);
            try {
                m_eta1_choice1->ReadCPACS(tixiHandle, xpath + "/eta1");
            } catch(const std::exception& e) {
                LOG(ERROR) << "Failed to read eta1 at xpath " << xpath << ": " << e.what();
                m_eta1_choice1 = boost::none;
            }
        }

        // read element eta2
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/eta2")) {
            m_eta2_choice1 = boost::in_place(reinterpret_cast<CCPACSWingCellPositionSpanwise*>(this), m_uidMgr);
            try {
                m_eta2_choice1->ReadCPACS(tixiHandle, xpath + "/eta2");
            } catch(const std::exception& e) {
                LOG(ERROR) << "Failed to read eta2 at xpath " << xpath << ": " << e.what();
                m_eta2_choice1 = boost::none;
            }
        }

        // read element ribNumber
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/ribNumber")) {
            m_ribNumber_choice2 = tixi::TixiGetElement<int>(tixiHandle, xpath + "/ribNumber");
        }

        // read element ribDefinitionUID
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/ribDefinitionUID")) {
            m_ribDefinitionUID_choice2 = tixi::TixiGetElement<std::string>(tixiHandle, xpath + "/ribDefinitionUID");
            if (m_ribDefinitionUID_choice2->empty()) {
                LOG(WARNING) << "Optional element ribDefinitionUID is present but empty at xpath " << xpath;
            }
            if (m_uidMgr && !m_ribDefinitionUID_choice2->empty()) m_uidMgr->RegisterReference(*m_ribDefinitionUID_choice2, *this);
        }

        if (!ValidateChoices()) {
            LOG(ERROR) << "Invalid choice configuration at xpath " << xpath;
        }
    }

    void CPACSCellPositioningSpanwise::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write element eta1
        if (m_eta1_choice1) {
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/eta1");
            m_eta1_choice1->WriteCPACS(tixiHandle, xpath + "/eta1");
        }
        else {
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/eta1")) {
                tixi::TixiRemoveElement(tixiHandle, xpath + "/eta1");
            }
        }

        // write element eta2
        if (m_eta2_choice1) {
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/eta2");
            m_eta2_choice1->WriteCPACS(tixiHandle, xpath + "/eta2");
        }
        else {
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/eta2")) {
                tixi::TixiRemoveElement(tixiHandle, xpath + "/eta2");
            }
        }

        // write element ribNumber
        if (m_ribNumber_choice2) {
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/ribNumber");
            tixi::TixiSaveElement(tixiHandle, xpath + "/ribNumber", *m_ribNumber_choice2);
        }
        else {
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/ribNumber")) {
                tixi::TixiRemoveElement(tixiHandle, xpath + "/ribNumber");
            }
        }

        // write element ribDefinitionUID
        if (m_ribDefinitionUID_choice2) {
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/ribDefinitionUID");
            tixi::TixiSaveElement(tixiHandle, xpath + "/ribDefinitionUID", *m_ribDefinitionUID_choice2);
        }
        else {
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/ribDefinitionUID")) {
                tixi::TixiRemoveElement(tixiHandle, xpath + "/ribDefinitionUID");
            }
        }

    }

    bool CPACSCellPositioningSpanwise::ValidateChoices() const
    {
        return
        (
            (
                (
                    // mandatory elements of this choice must be there
                    m_eta1_choice1.is_initialized()
                    &&
                    m_eta2_choice1.is_initialized()
                    &&
                    // elements of other choices must not be there
                    !(
                        m_ribNumber_choice2.is_initialized()
                        ||
                        m_ribDefinitionUID_choice2.is_initialized()
                    )
                )
                +
                (
                    // mandatory elements of this choice must be there
                    m_ribNumber_choice2.is_initialized()
                    &&
                    m_ribDefinitionUID_choice2.is_initialized()
                    &&
                    // elements of other choices must not be there
                    !(
                        m_eta1_choice1.is_initialized()
                        ||
                        m_eta2_choice1.is_initialized()
                    )
                )
                == 1
            )
        )
        ;
    }

    const boost::optional<CCPACSEtaIsoLine>& CPACSCellPositioningSpanwise::GetEta1_choice1() const
    {
        return m_eta1_choice1;
    }

    boost::optional<CCPACSEtaIsoLine>& CPACSCellPositioningSpanwise::GetEta1_choice1()
    {
        return m_eta1_choice1;
    }

    const boost::optional<CCPACSEtaIsoLine>& CPACSCellPositioningSpanwise::GetEta2_choice1() const
    {
        return m_eta2_choice1;
    }

    boost::optional<CCPACSEtaIsoLine>& CPACSCellPositioningSpanwise::GetEta2_choice1()
    {
        return m_eta2_choice1;
    }

    const boost::optional<int>& CPACSCellPositioningSpanwise::GetRibNumber_choice2() const
    {
        return m_ribNumber_choice2;
    }

    void CPACSCellPositioningSpanwise::SetRibNumber_choice2(const boost::optional<int>& value)
    {
        m_ribNumber_choice2 = value;
    }

    const boost::optional<std::string>& CPACSCellPositioningSpanwise::GetRibDefinitionUID_choice2() const
    {
        return m_ribDefinitionUID_choice2;
    }

    void CPACSCellPositioningSpanwise::SetRibDefinitionUID_choice2(const boost::optional<std::string>& value)
    {
        if (m_uidMgr) {
            if (m_ribDefinitionUID_choice2 && !m_ribDefinitionUID_choice2->empty()) m_uidMgr->TryUnregisterReference(*m_ribDefinitionUID_choice2, *this);
            if (value && !value->empty()) m_uidMgr->RegisterReference(*value, *this);
        }
        m_ribDefinitionUID_choice2 = value;
    }

    CCPACSEtaIsoLine& CPACSCellPositioningSpanwise::GetEta1_choice1(CreateIfNotExistsTag)
    {
        if (!m_eta1_choice1)
            m_eta1_choice1 = boost::in_place(reinterpret_cast<CCPACSWingCellPositionSpanwise*>(this), m_uidMgr);
        return *m_eta1_choice1;
    }

    void CPACSCellPositioningSpanwise::RemoveEta1_choice1()
    {
        m_eta1_choice1 = boost::none;
    }

    CCPACSEtaIsoLine& CPACSCellPositioningSpanwise::GetEta2_choice1(CreateIfNotExistsTag)
    {
        if (!m_eta2_choice1)
            m_eta2_choice1 = boost::in_place(reinterpret_cast<CCPACSWingCellPositionSpanwise*>(this), m_uidMgr);
        return *m_eta2_choice1;
    }

    void CPACSCellPositioningSpanwise::RemoveEta2_choice1()
    {
        m_eta2_choice1 = boost::none;
    }

    const CTiglUIDObject* CPACSCellPositioningSpanwise::GetNextUIDObject() const
    {
        return GetNextUIDParent();
    }

    void CPACSCellPositioningSpanwise::NotifyUIDChange(const std::string& oldUid, const std::string& newUid)
    {
        if (m_ribDefinitionUID_choice2 && *m_ribDefinitionUID_choice2 == oldUid) {
            m_ribDefinitionUID_choice2 = newUid;
        }
    }

} // namespace generated
} // namespace tigl
