// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include "CCPACSControlSurfaceWingCutOut.h"
#include "CPACSControlSurfaceSkinCutOut.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "CTiglUIDObject.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSControlSurfaceSkinCutOut::CPACSControlSurfaceSkinCutOut(CCPACSControlSurfaceWingCutOut* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSControlSurfaceSkinCutOut::~CPACSControlSurfaceSkinCutOut()
    {
        if (m_uidMgr) {
            if (m_sparUID_choice1 && !m_sparUID_choice1->empty()) m_uidMgr->TryUnregisterReference(*m_sparUID_choice1, *this);
        }
    }

    const CCPACSControlSurfaceWingCutOut* CPACSControlSurfaceSkinCutOut::GetParent() const
    {
        return m_parent;
    }

    CCPACSControlSurfaceWingCutOut* CPACSControlSurfaceSkinCutOut::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSControlSurfaceSkinCutOut::GetNextUIDParent() const
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDObject* CPACSControlSurfaceSkinCutOut::GetNextUIDParent()
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDManager& CPACSControlSurfaceSkinCutOut::GetUIDManager()
    {
        return *m_uidMgr;
    }

    const CTiglUIDManager& CPACSControlSurfaceSkinCutOut::GetUIDManager() const
    {
        return *m_uidMgr;
    }

    void CPACSControlSurfaceSkinCutOut::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read element sparUID
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/sparUID")) {
            m_sparUID_choice1 = tixi::TixiGetElement<std::string>(tixiHandle, xpath + "/sparUID");
            if (m_sparUID_choice1->empty()) {
                LOG(WARNING) << "Optional element sparUID is present but empty at xpath " << xpath;
            }
            if (m_uidMgr && !m_sparUID_choice1->empty()) m_uidMgr->RegisterReference(*m_sparUID_choice1, *this);
        }

        // read element xsiInnerBorder
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/xsiInnerBorder")) {
            m_xsiInnerBorder_choice2 = tixi::TixiGetElement<double>(tixiHandle, xpath + "/xsiInnerBorder");
        }

        // read element xsiOuterBorder
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/xsiOuterBorder")) {
            m_xsiOuterBorder_choice2 = tixi::TixiGetElement<double>(tixiHandle, xpath + "/xsiOuterBorder");
        }

        if (!ValidateChoices()) {
            LOG(ERROR) << "Invalid choice configuration at xpath " << xpath;
        }
    }

    void CPACSControlSurfaceSkinCutOut::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write element sparUID
        if (m_sparUID_choice1) {
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/sparUID");
            tixi::TixiSaveElement(tixiHandle, xpath + "/sparUID", *m_sparUID_choice1);
        }
        else {
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/sparUID")) {
                tixi::TixiRemoveElement(tixiHandle, xpath + "/sparUID");
            }
        }

        // write element xsiInnerBorder
        if (m_xsiInnerBorder_choice2) {
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/xsiInnerBorder");
            tixi::TixiSaveElement(tixiHandle, xpath + "/xsiInnerBorder", *m_xsiInnerBorder_choice2);
        }
        else {
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/xsiInnerBorder")) {
                tixi::TixiRemoveElement(tixiHandle, xpath + "/xsiInnerBorder");
            }
        }

        // write element xsiOuterBorder
        if (m_xsiOuterBorder_choice2) {
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/xsiOuterBorder");
            tixi::TixiSaveElement(tixiHandle, xpath + "/xsiOuterBorder", *m_xsiOuterBorder_choice2);
        }
        else {
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/xsiOuterBorder")) {
                tixi::TixiRemoveElement(tixiHandle, xpath + "/xsiOuterBorder");
            }
        }

    }

    bool CPACSControlSurfaceSkinCutOut::ValidateChoices() const
    {
        return
        (
            (
                (
                    // mandatory elements of this choice must be there
                    m_sparUID_choice1.is_initialized()
                    &&
                    // elements of other choices must not be there
                    !(
                        m_xsiInnerBorder_choice2.is_initialized()
                        ||
                        m_xsiOuterBorder_choice2.is_initialized()
                    )
                )
                +
                (
                    // mandatory elements of this choice must be there
                    m_xsiInnerBorder_choice2.is_initialized()
                    &&
                    m_xsiOuterBorder_choice2.is_initialized()
                    &&
                    // elements of other choices must not be there
                    !(
                        m_sparUID_choice1.is_initialized()
                    )
                )
                == 1
            )
        )
        ;
    }

    const boost::optional<std::string>& CPACSControlSurfaceSkinCutOut::GetSparUID_choice1() const
    {
        return m_sparUID_choice1;
    }

    void CPACSControlSurfaceSkinCutOut::SetSparUID_choice1(const boost::optional<std::string>& value)
    {
        if (m_uidMgr) {
            if (m_sparUID_choice1 && !m_sparUID_choice1->empty()) m_uidMgr->TryUnregisterReference(*m_sparUID_choice1, *this);
            if (value && !value->empty()) m_uidMgr->RegisterReference(*value, *this);
        }
        m_sparUID_choice1 = value;
    }

    const boost::optional<double>& CPACSControlSurfaceSkinCutOut::GetXsiInnerBorder_choice2() const
    {
        return m_xsiInnerBorder_choice2;
    }

    void CPACSControlSurfaceSkinCutOut::SetXsiInnerBorder_choice2(const boost::optional<double>& value)
    {
        m_xsiInnerBorder_choice2 = value;
    }

    const boost::optional<double>& CPACSControlSurfaceSkinCutOut::GetXsiOuterBorder_choice2() const
    {
        return m_xsiOuterBorder_choice2;
    }

    void CPACSControlSurfaceSkinCutOut::SetXsiOuterBorder_choice2(const boost::optional<double>& value)
    {
        m_xsiOuterBorder_choice2 = value;
    }

    const CTiglUIDObject* CPACSControlSurfaceSkinCutOut::GetNextUIDObject() const
    {
        return GetNextUIDParent();
    }

    void CPACSControlSurfaceSkinCutOut::NotifyUIDChange(const std::string& oldUid, const std::string& newUid)
    {
        if (m_sparUID_choice1 && *m_sparUID_choice1 == oldUid) {
            m_sparUID_choice1 = newUid;
        }
    }

} // namespace generated
} // namespace tigl
