// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include "CPACSControlSurfacePath.h"
#include "CPACSControlSurfaceStep.h"
#include "CPACSControlSurfaceSteps.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "CTiglUIDObject.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSControlSurfaceSteps::CPACSControlSurfaceSteps(CPACSControlSurfacePath* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSControlSurfaceSteps::~CPACSControlSurfaceSteps()
    {
    }

    const CPACSControlSurfacePath* CPACSControlSurfaceSteps::GetParent() const
    {
        return m_parent;
    }

    CPACSControlSurfacePath* CPACSControlSurfaceSteps::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSControlSurfaceSteps::GetNextUIDParent() const
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDObject* CPACSControlSurfaceSteps::GetNextUIDParent()
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDManager& CPACSControlSurfaceSteps::GetUIDManager()
    {
        return *m_uidMgr;
    }

    const CTiglUIDManager& CPACSControlSurfaceSteps::GetUIDManager() const
    {
        return *m_uidMgr;
    }

    void CPACSControlSurfaceSteps::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read element step
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/step")) {
            tixi::TixiReadElements(tixiHandle, xpath + "/step", m_steps, 2, tixi::xsdUnbounded, this, m_uidMgr);
        }

    }

    void CPACSControlSurfaceSteps::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write element step
        tixi::TixiSaveElements(tixiHandle, xpath + "/step", m_steps);

    }

    const std::vector<std::unique_ptr<CPACSControlSurfaceStep>>& CPACSControlSurfaceSteps::GetSteps() const
    {
        return m_steps;
    }

    std::vector<std::unique_ptr<CPACSControlSurfaceStep>>& CPACSControlSurfaceSteps::GetSteps()
    {
        return m_steps;
    }

    CPACSControlSurfaceStep& CPACSControlSurfaceSteps::AddStep()
    {
        m_steps.push_back(make_unique<CPACSControlSurfaceStep>(this, m_uidMgr));
        return *m_steps.back();
    }

    void CPACSControlSurfaceSteps::RemoveStep(CPACSControlSurfaceStep& ref)
    {
        for (std::size_t i = 0; i < m_steps.size(); i++) {
            if (m_steps[i].get() == &ref) {
                m_steps.erase(m_steps.begin() + i);
                return;
            }
        }
        throw CTiglError("Element not found");
    }

} // namespace generated
} // namespace tigl
