// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include "CCPACSTrailingEdgeDevice.h"
#include "CPACSControlSurfaceTracks.h"
#include "CPACSControlSurfaceTrackType.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "CTiglUIDObject.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSControlSurfaceTracks::CPACSControlSurfaceTracks(CCPACSTrailingEdgeDevice* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSControlSurfaceTracks::~CPACSControlSurfaceTracks()
    {
    }

    const CCPACSTrailingEdgeDevice* CPACSControlSurfaceTracks::GetParent() const
    {
        return m_parent;
    }

    CCPACSTrailingEdgeDevice* CPACSControlSurfaceTracks::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSControlSurfaceTracks::GetNextUIDParent() const
    {
        return m_parent;
    }

    CTiglUIDObject* CPACSControlSurfaceTracks::GetNextUIDParent()
    {
        return m_parent;
    }

    CTiglUIDManager& CPACSControlSurfaceTracks::GetUIDManager()
    {
        return *m_uidMgr;
    }

    const CTiglUIDManager& CPACSControlSurfaceTracks::GetUIDManager() const
    {
        return *m_uidMgr;
    }

    void CPACSControlSurfaceTracks::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read element track
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/track")) {
            tixi::TixiReadElements(tixiHandle, xpath + "/track", m_tracks, 1, tixi::xsdUnbounded, this, m_uidMgr);
        }

    }

    void CPACSControlSurfaceTracks::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write element track
        tixi::TixiSaveElements(tixiHandle, xpath + "/track", m_tracks);

    }

    const std::vector<std::unique_ptr<CPACSControlSurfaceTrackType>>& CPACSControlSurfaceTracks::GetTracks() const
    {
        return m_tracks;
    }

    std::vector<std::unique_ptr<CPACSControlSurfaceTrackType>>& CPACSControlSurfaceTracks::GetTracks()
    {
        return m_tracks;
    }

    CPACSControlSurfaceTrackType& CPACSControlSurfaceTracks::AddTrack()
    {
        m_tracks.push_back(make_unique<CPACSControlSurfaceTrackType>(this, m_uidMgr));
        return *m_tracks.back();
    }

    void CPACSControlSurfaceTracks::RemoveTrack(CPACSControlSurfaceTrackType& ref)
    {
        for (std::size_t i = 0; i < m_tracks.size(); i++) {
            if (m_tracks[i].get() == &ref) {
                m_tracks.erase(m_tracks.begin() + i);
                return;
            }
        }
        throw CTiglError("Element not found");
    }

} // namespace generated
} // namespace tigl
