// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include <CCPACSGenericSystem.h>
#include "CCPACSACSystems.h"
#include "CPACSGenericSystems.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "CTiglUIDObject.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSGenericSystems::CPACSGenericSystems(CCPACSACSystems* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSGenericSystems::~CPACSGenericSystems()
    {
    }

    const CCPACSACSystems* CPACSGenericSystems::GetParent() const
    {
        return m_parent;
    }

    CCPACSACSystems* CPACSGenericSystems::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSGenericSystems::GetNextUIDParent() const
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDObject* CPACSGenericSystems::GetNextUIDParent()
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDManager& CPACSGenericSystems::GetUIDManager()
    {
        return *m_uidMgr;
    }

    const CTiglUIDManager& CPACSGenericSystems::GetUIDManager() const
    {
        return *m_uidMgr;
    }

    void CPACSGenericSystems::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read element genericSystem
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/genericSystem")) {
            tixi::TixiReadElements(tixiHandle, xpath + "/genericSystem", m_genericSystems, 1, tixi::xsdUnbounded, reinterpret_cast<CCPACSGenericSystems*>(this), m_uidMgr);
        }

    }

    void CPACSGenericSystems::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write element genericSystem
        tixi::TixiSaveElements(tixiHandle, xpath + "/genericSystem", m_genericSystems);

    }

    const std::vector<std::unique_ptr<CCPACSGenericSystem>>& CPACSGenericSystems::GetGenericSystems() const
    {
        return m_genericSystems;
    }

    std::vector<std::unique_ptr<CCPACSGenericSystem>>& CPACSGenericSystems::GetGenericSystems()
    {
        return m_genericSystems;
    }

    CCPACSGenericSystem& CPACSGenericSystems::AddGenericSystem()
    {
        m_genericSystems.push_back(make_unique<CCPACSGenericSystem>(reinterpret_cast<CCPACSGenericSystems*>(this), m_uidMgr));
        return *m_genericSystems.back();
    }

    void CPACSGenericSystems::RemoveGenericSystem(CCPACSGenericSystem& ref)
    {
        for (std::size_t i = 0; i < m_genericSystems.size(); i++) {
            if (m_genericSystems[i].get() == &ref) {
                m_genericSystems.erase(m_genericSystems.begin() + i);
                return;
            }
        }
        throw CTiglError("Element not found");
    }

} // namespace generated
} // namespace tigl
