// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include "CPACSMaterials.h"
#include "CPACSVehicles.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "CTiglUIDObject.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSMaterials::CPACSMaterials(CPACSVehicles* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSMaterials::~CPACSMaterials()
    {
    }

    const CPACSVehicles* CPACSMaterials::GetParent() const
    {
        return m_parent;
    }

    CPACSVehicles* CPACSMaterials::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSMaterials::GetNextUIDParent() const
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDObject* CPACSMaterials::GetNextUIDParent()
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDManager& CPACSMaterials::GetUIDManager()
    {
        return *m_uidMgr;
    }

    const CTiglUIDManager& CPACSMaterials::GetUIDManager() const
    {
        return *m_uidMgr;
    }

    void CPACSMaterials::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read element composites
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/composites")) {
            m_composites = boost::in_place(this, m_uidMgr);
            try {
                m_composites->ReadCPACS(tixiHandle, xpath + "/composites");
            } catch(const std::exception& e) {
                LOG(ERROR) << "Failed to read composites at xpath " << xpath << ": " << e.what();
                m_composites = boost::none;
            }
        }

    }

    void CPACSMaterials::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        const std::vector<std::string> childElemOrder = { "composites" };

        // write element composites
        if (m_composites) {
            tixi::TixiCreateSequenceElementIfNotExists(tixiHandle, xpath + "/composites", childElemOrder);
            m_composites->WriteCPACS(tixiHandle, xpath + "/composites");
        }
        else {
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/composites")) {
                tixi::TixiRemoveElement(tixiHandle, xpath + "/composites");
            }
        }

    }

    const boost::optional<CPACSComposites>& CPACSMaterials::GetComposites() const
    {
        return m_composites;
    }

    boost::optional<CPACSComposites>& CPACSMaterials::GetComposites()
    {
        return m_composites;
    }

    CPACSComposites& CPACSMaterials::GetComposites(CreateIfNotExistsTag)
    {
        if (!m_composites)
            m_composites = boost::in_place(this, m_uidMgr);
        return *m_composites;
    }

    void CPACSMaterials::RemoveComposites()
    {
        m_composites = boost::none;
    }

} // namespace generated
} // namespace tigl
