// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include "CPACSPointZ.h"
#include "CPACSTransformation2D.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSPointZ::CPACSPointZ(CPACSTransformation2D* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
        , m_z(0)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSPointZ::~CPACSPointZ()
    {
        if (m_uidMgr) m_uidMgr->TryUnregisterObject(m_uID);
    }

    const CPACSTransformation2D* CPACSPointZ::GetParent() const
    {
        return m_parent;
    }

    CPACSTransformation2D* CPACSPointZ::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSPointZ::GetNextUIDParent() const
    {
        return m_parent;
    }

    CTiglUIDObject* CPACSPointZ::GetNextUIDParent()
    {
        return m_parent;
    }

    CTiglUIDManager& CPACSPointZ::GetUIDManager()
    {
        return *m_uidMgr;
    }

    const CTiglUIDManager& CPACSPointZ::GetUIDManager() const
    {
        return *m_uidMgr;
    }

    void CPACSPointZ::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read attribute uID
        if (tixi::TixiCheckAttribute(tixiHandle, xpath, "uID")) {
            m_uID = tixi::TixiGetAttribute<std::string>(tixiHandle, xpath, "uID");
            if (m_uID.empty()) {
                LOG(WARNING) << "Required attribute uID is empty at xpath " << xpath;
            }
        }
        else {
            LOG(ERROR) << "Required attribute uID is missing at xpath " << xpath;
        }

        // read element z
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/z")) {
            m_z = tixi::TixiGetElement<double>(tixiHandle, xpath + "/z");
        }
        else {
            LOG(ERROR) << "Required element z is missing at xpath " << xpath;
        }

        if (m_uidMgr && !m_uID.empty()) m_uidMgr->RegisterObject(m_uID, *this);
    }

    void CPACSPointZ::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write attribute uID
        tixi::TixiSaveAttribute(tixiHandle, xpath, "uID", m_uID);

        // write element z
        tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/z");
        tixi::TixiSaveElement(tixiHandle, xpath + "/z", m_z);

    }

    const std::string& CPACSPointZ::GetUID() const
    {
        return m_uID;
    }

    void CPACSPointZ::SetUID(const std::string& value)
    {
        if (m_uidMgr && value != m_uID) {
            if (m_uID.empty()) {
                m_uidMgr->RegisterObject(value, *this);
            }
            else {
                m_uidMgr->UpdateObjectUID(m_uID, value);
            }
        }
        m_uID = value;
    }

    const double& CPACSPointZ::GetZ() const
    {
        return m_z;
    }

    void CPACSPointZ::SetZ(const double& value)
    {
        m_z = value;
    }

} // namespace generated
} // namespace tigl
