// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include "CPACSSheetBasedStructuralElement.h"
#include "CPACSSheetBasedStructuralElements.h"
#include "CPACSStructuralElements.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "CTiglUIDObject.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSSheetBasedStructuralElements::CPACSSheetBasedStructuralElements(CPACSStructuralElements* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSSheetBasedStructuralElements::~CPACSSheetBasedStructuralElements()
    {
    }

    const CPACSStructuralElements* CPACSSheetBasedStructuralElements::GetParent() const
    {
        return m_parent;
    }

    CPACSStructuralElements* CPACSSheetBasedStructuralElements::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSSheetBasedStructuralElements::GetNextUIDParent() const
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDObject* CPACSSheetBasedStructuralElements::GetNextUIDParent()
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDManager& CPACSSheetBasedStructuralElements::GetUIDManager()
    {
        return *m_uidMgr;
    }

    const CTiglUIDManager& CPACSSheetBasedStructuralElements::GetUIDManager() const
    {
        return *m_uidMgr;
    }

    void CPACSSheetBasedStructuralElements::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read element sheetBasedStructuralElement
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/sheetBasedStructuralElement")) {
            tixi::TixiReadElements(tixiHandle, xpath + "/sheetBasedStructuralElement", m_sheetBasedStructuralElements, 1, tixi::xsdUnbounded, this, m_uidMgr);
        }

    }

    void CPACSSheetBasedStructuralElements::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write element sheetBasedStructuralElement
        tixi::TixiSaveElements(tixiHandle, xpath + "/sheetBasedStructuralElement", m_sheetBasedStructuralElements);

    }

    const std::vector<std::unique_ptr<CPACSSheetBasedStructuralElement>>& CPACSSheetBasedStructuralElements::GetSheetBasedStructuralElements() const
    {
        return m_sheetBasedStructuralElements;
    }

    std::vector<std::unique_ptr<CPACSSheetBasedStructuralElement>>& CPACSSheetBasedStructuralElements::GetSheetBasedStructuralElements()
    {
        return m_sheetBasedStructuralElements;
    }

    CPACSSheetBasedStructuralElement& CPACSSheetBasedStructuralElements::AddSheetBasedStructuralElement()
    {
        m_sheetBasedStructuralElements.push_back(make_unique<CPACSSheetBasedStructuralElement>(this, m_uidMgr));
        return *m_sheetBasedStructuralElements.back();
    }

    void CPACSSheetBasedStructuralElements::RemoveSheetBasedStructuralElement(CPACSSheetBasedStructuralElement& ref)
    {
        for (std::size_t i = 0; i < m_sheetBasedStructuralElements.size(); i++) {
            if (m_sheetBasedStructuralElements[i].get() == &ref) {
                m_sheetBasedStructuralElements.erase(m_sheetBasedStructuralElements.begin() + i);
                return;
            }
        }
        throw CTiglError("Element not found");
    }

} // namespace generated
} // namespace tigl
