// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include "CPACSSparCell.h"
#include "CPACSSparCells.h"
#include "CPACSSparCrossSection.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "CTiglUIDObject.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSSparCells::CPACSSparCells(CPACSSparCrossSection* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSSparCells::~CPACSSparCells()
    {
    }

    const CPACSSparCrossSection* CPACSSparCells::GetParent() const
    {
        return m_parent;
    }

    CPACSSparCrossSection* CPACSSparCells::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSSparCells::GetNextUIDParent() const
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDObject* CPACSSparCells::GetNextUIDParent()
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDManager& CPACSSparCells::GetUIDManager()
    {
        return *m_uidMgr;
    }

    const CTiglUIDManager& CPACSSparCells::GetUIDManager() const
    {
        return *m_uidMgr;
    }

    void CPACSSparCells::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read element sparCell
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/sparCell")) {
            tixi::TixiReadElements(tixiHandle, xpath + "/sparCell", m_sparCells, 1, tixi::xsdUnbounded, this, m_uidMgr);
        }

    }

    void CPACSSparCells::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write element sparCell
        tixi::TixiSaveElements(tixiHandle, xpath + "/sparCell", m_sparCells);

    }

    const std::vector<std::unique_ptr<CPACSSparCell>>& CPACSSparCells::GetSparCells() const
    {
        return m_sparCells;
    }

    std::vector<std::unique_ptr<CPACSSparCell>>& CPACSSparCells::GetSparCells()
    {
        return m_sparCells;
    }

    CPACSSparCell& CPACSSparCells::AddSparCell()
    {
        m_sparCells.push_back(make_unique<CPACSSparCell>(this, m_uidMgr));
        return *m_sparCells.back();
    }

    void CPACSSparCells::RemoveSparCell(CPACSSparCell& ref)
    {
        for (std::size_t i = 0; i < m_sparCells.size(); i++) {
            if (m_sparCells[i].get() == &ref) {
                m_sparCells.erase(m_sparCells.begin() + i);
                return;
            }
        }
        throw CTiglError("Element not found");
    }

} // namespace generated
} // namespace tigl
