// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include "CPACSCFDTool.h"
#include "CPACSTool.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDObject.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSTool::CPACSTool(CPACSCFDTool* parent)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSTool::~CPACSTool()
    {
    }

    const CPACSCFDTool* CPACSTool::GetParent() const
    {
        return m_parent;
    }

    CPACSCFDTool* CPACSTool::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSTool::GetNextUIDParent() const
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDObject* CPACSTool::GetNextUIDParent()
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    void CPACSTool::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read element name
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/name")) {
            m_name = tixi::TixiGetElement<std::string>(tixiHandle, xpath + "/name");
            if (m_name.empty()) {
                LOG(WARNING) << "Required element name is empty at xpath " << xpath;
            }
        }
        else {
            LOG(ERROR) << "Required element name is missing at xpath " << xpath;
        }

        // read element version
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/version")) {
            m_version = tixi::TixiGetElement<std::string>(tixiHandle, xpath + "/version");
            if (m_version.empty()) {
                LOG(WARNING) << "Required element version is empty at xpath " << xpath;
            }
        }
        else {
            LOG(ERROR) << "Required element version is missing at xpath " << xpath;
        }

    }

    void CPACSTool::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write element name
        tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/name");
        tixi::TixiSaveElement(tixiHandle, xpath + "/name", m_name);

        // write element version
        tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/version");
        tixi::TixiSaveElement(tixiHandle, xpath + "/version", m_version);

    }

    const std::string& CPACSTool::GetName() const
    {
        return m_name;
    }

    void CPACSTool::SetName(const std::string& value)
    {
        m_name = value;
    }

    const std::string& CPACSTool::GetVersion() const
    {
        return m_version;
    }

    void CPACSTool::SetVersion(const std::string& value)
    {
        m_version = value;
    }

} // namespace generated
} // namespace tigl
