// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include <CCPACSWallPosition.h>
#include "CCPACSWalls.h"
#include "CPACSWallPositions.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "CTiglUIDObject.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSWallPositions::CPACSWallPositions(CCPACSWalls* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSWallPositions::~CPACSWallPositions()
    {
    }

    const CCPACSWalls* CPACSWallPositions::GetParent() const
    {
        return m_parent;
    }

    CCPACSWalls* CPACSWallPositions::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSWallPositions::GetNextUIDParent() const
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDObject* CPACSWallPositions::GetNextUIDParent()
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDManager& CPACSWallPositions::GetUIDManager()
    {
        return *m_uidMgr;
    }

    const CTiglUIDManager& CPACSWallPositions::GetUIDManager() const
    {
        return *m_uidMgr;
    }

    void CPACSWallPositions::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read element wallPosition
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/wallPosition")) {
            tixi::TixiReadElements(tixiHandle, xpath + "/wallPosition", m_wallPositions, 2, tixi::xsdUnbounded, this, m_uidMgr);
        }

    }

    void CPACSWallPositions::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write element wallPosition
        tixi::TixiSaveElements(tixiHandle, xpath + "/wallPosition", m_wallPositions);

    }

    const std::vector<std::unique_ptr<CCPACSWallPosition>>& CPACSWallPositions::GetWallPositions() const
    {
        return m_wallPositions;
    }

    std::vector<std::unique_ptr<CCPACSWallPosition>>& CPACSWallPositions::GetWallPositions()
    {
        return m_wallPositions;
    }

    CCPACSWallPosition& CPACSWallPositions::AddWallPosition()
    {
        m_wallPositions.push_back(make_unique<CCPACSWallPosition>(this, m_uidMgr));
        return *m_wallPositions.back();
    }

    void CPACSWallPositions::RemoveWallPosition(CCPACSWallPosition& ref)
    {
        for (std::size_t i = 0; i < m_wallPositions.size(); i++) {
            if (m_wallPositions[i].get() == &ref) {
                m_wallPositions.erase(m_wallPositions.begin() + i);
                return;
            }
        }
        throw CTiglError("Element not found");
    }

} // namespace generated
} // namespace tigl
