// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include "CCPACSWingCell.h"
#include "CCPACSWingShell.h"
#include "CPACSWingSkin.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "CTiglUIDObject.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSWingSkin::CPACSWingSkin(CCPACSWingCell* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
        , m_material(this, m_uidMgr)
    {
        //assert(parent != NULL);
        m_parent = parent;
        m_parentType = &typeid(CCPACSWingCell);
    }

    CPACSWingSkin::CPACSWingSkin(CCPACSWingShell* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
        , m_material(this, m_uidMgr)
    {
        //assert(parent != NULL);
        m_parent = parent;
        m_parentType = &typeid(CCPACSWingShell);
    }

    CPACSWingSkin::~CPACSWingSkin()
    {
    }

    const CTiglUIDObject* CPACSWingSkin::GetNextUIDParent() const
    {
        if (m_parent) {
            if (IsParent<CCPACSWingCell>()) {
                return GetParent<CCPACSWingCell>();
            }
            if (IsParent<CCPACSWingShell>()) {
                return GetParent<CCPACSWingShell>();
            }
        }
        return nullptr;
    }

    CTiglUIDObject* CPACSWingSkin::GetNextUIDParent()
    {
        if (m_parent) {
            if (IsParent<CCPACSWingCell>()) {
                return GetParent<CCPACSWingCell>();
            }
            if (IsParent<CCPACSWingShell>()) {
                return GetParent<CCPACSWingShell>();
            }
        }
        return nullptr;
    }

    CTiglUIDManager& CPACSWingSkin::GetUIDManager()
    {
        return *m_uidMgr;
    }

    const CTiglUIDManager& CPACSWingSkin::GetUIDManager() const
    {
        return *m_uidMgr;
    }

    void CPACSWingSkin::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read element material
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/material")) {
            m_material.ReadCPACS(tixiHandle, xpath + "/material");
        }
        else {
            LOG(ERROR) << "Required element material is missing at xpath " << xpath;
        }

    }

    void CPACSWingSkin::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write element material
        tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/material");
        m_material.WriteCPACS(tixiHandle, xpath + "/material");

    }

    const CCPACSMaterialDefinition& CPACSWingSkin::GetMaterial() const
    {
        return m_material;
    }

    CCPACSMaterialDefinition& CPACSWingSkin::GetMaterial()
    {
        return m_material;
    }

} // namespace generated
} // namespace tigl
