// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include "CCPACSControlSurfaceBorderTrailingEdge.h"
#include "CPACSXsiIsoLine.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "CTiglUIDObject.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSXsiIsoLine::CPACSXsiIsoLine(CCPACSControlSurfaceBorderTrailingEdge* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
        , m_xsi(0)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSXsiIsoLine::~CPACSXsiIsoLine()
    {
        if (m_uidMgr) {
            if (!m_referenceUID.empty()) m_uidMgr->TryUnregisterReference(m_referenceUID, *this);
        }
    }

    const CCPACSControlSurfaceBorderTrailingEdge* CPACSXsiIsoLine::GetParent() const
    {
        return m_parent;
    }

    CCPACSControlSurfaceBorderTrailingEdge* CPACSXsiIsoLine::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSXsiIsoLine::GetNextUIDParent() const
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDObject* CPACSXsiIsoLine::GetNextUIDParent()
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDManager& CPACSXsiIsoLine::GetUIDManager()
    {
        return *m_uidMgr;
    }

    const CTiglUIDManager& CPACSXsiIsoLine::GetUIDManager() const
    {
        return *m_uidMgr;
    }

    void CPACSXsiIsoLine::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read element xsi
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/xsi")) {
            m_xsi = tixi::TixiGetElement<double>(tixiHandle, xpath + "/xsi");
        }
        else {
            LOG(ERROR) << "Required element xsi is missing at xpath " << xpath;
        }

        // read element referenceUID
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/referenceUID")) {
            m_referenceUID = tixi::TixiGetElement<std::string>(tixiHandle, xpath + "/referenceUID");
            if (m_referenceUID.empty()) {
                LOG(WARNING) << "Required element referenceUID is empty at xpath " << xpath;
            }
            if (m_uidMgr && !m_referenceUID.empty()) m_uidMgr->RegisterReference(m_referenceUID, *this);
        }
        else {
            LOG(ERROR) << "Required element referenceUID is missing at xpath " << xpath;
        }

    }

    void CPACSXsiIsoLine::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write element xsi
        tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/xsi");
        tixi::TixiSaveElement(tixiHandle, xpath + "/xsi", m_xsi);

        // write element referenceUID
        tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/referenceUID");
        tixi::TixiSaveElement(tixiHandle, xpath + "/referenceUID", m_referenceUID);

    }

    const double& CPACSXsiIsoLine::GetXsi() const
    {
        return m_xsi;
    }

    void CPACSXsiIsoLine::SetXsi(const double& value)
    {
        m_xsi = value;
    }

    const std::string& CPACSXsiIsoLine::GetReferenceUID() const
    {
        return m_referenceUID;
    }

    void CPACSXsiIsoLine::SetReferenceUID(const std::string& value)
    {
        if (m_uidMgr) {
            if (!m_referenceUID.empty()) m_uidMgr->TryUnregisterReference(m_referenceUID, *this);
            if (!value.empty()) m_uidMgr->RegisterReference(value, *this);
        }
        m_referenceUID = value;
    }

    const CTiglUIDObject* CPACSXsiIsoLine::GetNextUIDObject() const
    {
        return GetNextUIDParent();
    }

    void CPACSXsiIsoLine::NotifyUIDChange(const std::string& oldUid, const std::string& newUid)
    {
        if (m_referenceUID == oldUid) {
            m_referenceUID = newUid;
        }
    }

} // namespace generated
} // namespace tigl
